require "import"
import "android.content.Context"
import "android.os.Vibrator"

local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(100)

local function generateRandomPassword(length, uppercase, lowercase, numbers, specials)
    local chars = ""

    if uppercase then
        chars = chars .. "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    end

    if lowercase then
        chars = chars .. "abcdefghijklmnopqrstuvwxyz"
    end

    if numbers then
        chars = chars .. "0123456789"
    end

    if specials then
        chars = chars .. "!@#$%^&*()_-+={}[]:;<>,.?/|~"
    end

    -- Add additional special characters or emoticons
    chars = chars .. "♪♫♡♥☺☻"
  
    -- Additional symbols and emoticons
    chars = chars .. "@#~`$%*+=[]\\;/{}|\":<>"
  
    -- Additional emojis
    chars = chars .. "😀😃😄😁😆😅🤣😂🙂🙃😉😊😇😍😘😗😚😙😋😛😝😜🤪🤨🧐🤓"

    local password = ""
    local firstCharacter = true
    while #password < length do
        local randomIndex = math.random(1, #chars)
        local randomChar = chars:sub(randomIndex, randomIndex)
        
        if firstCharacter and (string.match(randomChar, "%a") or string.match(randomChar, "%d")) then
            password = password .. randomChar
            firstCharacter = false
        elseif not firstCharacter then
            password = password .. randomChar
        end
    end

    return password
end

local passwordLength = 16
local randomPassword = generateRandomPassword(passwordLength, true, true, true, true)
service.addFavorites(randomPassword)
service.setText(randomPassword)
service.asyncSpeak("Mật khẩu ngẫu nhiên của bạn là: ".. randomPassword)